diff --git a/mutt_notmuch.c b/mutt_notmuch.c
index 76ca5fc8b7..1a7d1b0fdf 100644
--- a/mutt_notmuch.c
+++ b/mutt_notmuch.c
@@ -482,18 +482,32 @@ static notmuch_database_t *do_database_open(const char *filename, bool writable,
   notmuch_database_t *db = NULL;
   int ct = 0;
   notmuch_status_t st = NOTMUCH_STATUS_SUCCESS;
+  char *msg = NULL;
 
   mutt_debug(1, "nm: db open '%s' %s (timeout %d)\n", filename,
              writable ? "[WRITE]" : "[READ]", NmOpenTimeout);
   do
   {
-#ifdef NOTMUCH_API_3
+#if LIBNOTMUCH_CHECK_VERSION(4, 3, 0)
+    st = notmuch_database_open_verbose(
+        filename, writable ? NOTMUCH_DATABASE_MODE_READ_WRITE : NOTMUCH_DATABASE_MODE_READ_ONLY,
+        &db, &msg);
+#elif defined(NOTMUCH_API_3)
     st = notmuch_database_open(filename, writable ? NOTMUCH_DATABASE_MODE_READ_WRITE : NOTMUCH_DATABASE_MODE_READ_ONLY,
                                &db);
 #else
     db = notmuch_database_open(filename, writable ? NOTMUCH_DATABASE_MODE_READ_WRITE :
                                                     NOTMUCH_DATABASE_MODE_READ_ONLY);
 #endif
+    if (st == NOTMUCH_STATUS_FILE_ERROR)
+    {
+      if (msg)
+      {
+        mutt_error(msg);
+        FREE(&msg);
+      }
+      return NULL;
+    }
     if (db || !NmOpenTimeout || ((ct / 2) > NmOpenTimeout))
       break;
 
